<?php
/**
 * Corporate Office functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package Corporate Office
 */

include get_theme_file_path( 'vendor/wptrt/autoload/src/Corporate_Office_Loader.php' );

$Corporate_Office_Loader = new \WPTRT\Autoload\Corporate_Office_Loader();

$Corporate_Office_Loader->corporate_office_add( 'WPTRT\\Customize\\Section', get_theme_file_path( 'vendor/wptrt/customize-section-button/src' ) );

$Corporate_Office_Loader->corporate_office_register();

if ( ! function_exists( 'corporate_office_setup' ) ) :

	function corporate_office_setup() {

		/*
		 * Enable support for Post Formats.
		 *
		 * See: https://codex.wordpress.org/Post_Formats
		*/
		add_theme_support( 'post-formats', array('image','video','gallery','audio',) );

		load_theme_textdomain( 'corporate-office', get_template_directory() . '/languages' );
		add_theme_support( 'woocommerce' );
		add_theme_support( "responsive-embeds" );
		add_theme_support( "align-wide" );
		add_theme_support( "wp-block-styles" );
		add_theme_support( 'automatic-feed-links' );
		add_theme_support( 'title-tag' );
		add_theme_support( 'post-thumbnails' );
        add_image_size('corporate-office-featured-header-image', 2000, 660, true);

        register_nav_menus( array(
            'primary' => esc_html__( 'Primary','corporate-office' ),
	        'footer'=> esc_html__( 'Footer Menu','corporate-office' ),
        ) );

		add_theme_support( 'html5', array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
		) );

		add_theme_support( 'custom-background', apply_filters( 'corporate_office_custom_background_args', array(
			'default-color' => 'f7ebe5',
			'default-image' => '',
		) ) );

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support( 'custom-logo', array(
			'height'      => 50,
			'width'       => 50,
			'flex-width'  => true,
		) );

		add_editor_style( array( '/editor-style.css' ) );
		add_action('wp_ajax_corporate_office_dismissable_notice', 'corporate_office_dismissable_notice');
		add_action( 'wp_ajax_tm-check-plugin-exists', 'tm_check_plugin_exists' );
		add_action( 'wp_ajax_tm_install_and_activate_plugin', 'tm_install_and_activate_plugin' );
	}
endif;
add_action( 'after_setup_theme', 'corporate_office_setup' );

function tm_install_and_activate_plugin() {

	check_ajax_referer( 'theme_importer_nonce' );

	if ( ! current_user_can( 'activate_plugins' ) ) {
		wp_send_json_error( 'Permission denied.' );
		return;
	}

	$post_plugin_details = isset( $_POST['plugin_details'] ) ? $_POST['plugin_details'] : array();
	$plugin_text_domain  = isset( $post_plugin_details['plugin_text_domain'] ) ? sanitize_key( wp_unslash( $post_plugin_details['plugin_text_domain'] ) ) : '';
	$plugin_main_file    = isset( $post_plugin_details['plugin_main_file'] ) ? sanitize_file_name( wp_unslash( $post_plugin_details['plugin_main_file'] ) ) : '';
	$plugin_url          = isset( $post_plugin_details['plugin_url'] ) ? esc_url_raw( wp_unslash( $post_plugin_details['plugin_url'] ) ) : '';

	$plugin = array(
		'text_domain' => $plugin_text_domain,
		'path'        => $plugin_url,
		'install'     => $plugin_text_domain . '/' . $plugin_main_file,
	);

	wp_cache_flush();

	$plugin_path = plugin_basename( trim( $plugin['install'] ) );

	$activate_plugin = activate_plugin( $plugin_path );

	if ( $activate_plugin ) {
		echo $activate_plugin;
	} else {
		echo $activate_plugin;
	}

	$msg = 'installed';

	$response = array( 'status' => true, 'msg' => $msg );
	wp_send_json( $response );
	wp_die();
}

function tm_check_plugin_exists() {

	check_ajax_referer( 'theme_importer_nonce' );

	if ( ! current_user_can( 'activate_plugins' ) ) {
		wp_send_json_error( array( 'install_status' => false, 'active_status' => false ) );
		return;
	}

	$plugin_text_domain = isset( $_POST['plugin_text_domain'] ) ? sanitize_key( wp_unslash( $_POST['plugin_text_domain'] ) ) : '';
	$main_plugin_file   = isset( $_POST['main_plugin_file'] ) ? sanitize_file_name( wp_unslash( $_POST['main_plugin_file'] ) ) : '';
	$plugin_path        = $plugin_text_domain . '/' . $main_plugin_file;

	$get_plugins         = get_plugins();
	$is_plugin_installed = false;
	$activation_status   = false;
	if ( isset( $get_plugins[ $plugin_path ] ) ) {
		$is_plugin_installed = true;
		$activation_status   = is_plugin_active( $plugin_path );
	}
	wp_send_json_success(
		array(
			'install_status' => $is_plugin_installed,
			'active_status'  => $activation_status,
			'plugin_path'    => $plugin_path,
			'plugin_slug'    => $plugin_text_domain,
		)
	);
}


function corporate_office_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'corporate_office_content_width', 1170 );
}
add_action( 'after_setup_theme', 'corporate_office_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function corporate_office_widgets_init() {
	register_sidebar( array(
		'name'          => esc_html__( 'Sidebar', 'corporate-office' ),
		'id'            => 'sidebar',
		'description'   => esc_html__( 'Add widgets here.', 'corporate-office' ),
        'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h5 class="widget-title">',
		'after_title'   => '</h5>',
	) );

	register_sidebar( array(
		'name'          => esc_html__( 'Sidebar 1', 'corporate-office' ),
		'id'            => 'sidebar1',
		'description'   => esc_html__( 'Add widgets here.', 'corporate-office' ),
        'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h5 class="widget-title">',
		'after_title'   => '</h5>',
	) );

	register_sidebar( array(
		'name'          => esc_html__( 'Sidebar 2', 'corporate-office' ),
		'id'            => 'sidebar2',
		'description'   => esc_html__( 'Add widgets here.', 'corporate-office' ),
        'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h5 class="widget-title">',
		'after_title'   => '</h5>',
	) );

	register_sidebar( array(
		'name'          => esc_html__( 'Footer Column 1', 'corporate-office' ),
		'id'            => 'corporate-office-footer1',
		'description'   => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h5 class="footer-column-widget-title">',
		'after_title'   => '</h5>',
	) );

	register_sidebar( array(
		'name'          => esc_html__( 'Footer Column 2', 'corporate-office' ),
		'id'            => 'corporate-office-footer2',
		'description'   => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h5 class="footer-column-widget-title">',
		'after_title'   => '</h5>',
	) );

	register_sidebar( array(
		'name'          => esc_html__( 'Footer Column 3', 'corporate-office' ),
		'id'            => 'corporate-office-footer3',
		'description'   => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget'  => '</aside>',
		'before_title'  => '<h5 class="footer-column-widget-title">',
		'after_title'   => '</h5>',
	) );
}
add_action( 'widgets_init', 'corporate_office_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function corporate_office_scripts() {

	require_once get_theme_file_path( 'inc/wptt-webfont-loader.php' );

	wp_enqueue_style(
		'poppins',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap" rel="stylesheet"' ),
		array(),
		'1.0'
	);

	wp_enqueue_style(
		'public-sans',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Public+Sans:ital,wght@0,100..900;1,100..900&display=swap" rel="stylesheet' ),
		array(),
		'1.0'
	);

	wp_enqueue_style( 'corporate-office-block-editor-style', get_theme_file_uri('/assets/css/block-editor-style.css') );

	// load bootstrap css
    wp_enqueue_style( 'bootstrap-css', get_template_directory_uri() . '/assets/css/bootstrap.css');

    wp_enqueue_style( 'owl.carousel-css', get_template_directory_uri() . '/assets/css/owl.carousel.css');

	wp_enqueue_style( 'corporate-office-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom-option.php' );
	wp_add_inline_style( 'corporate-office-style',$corporate_office_theme_css );

	// fontawesome
	wp_enqueue_style( 'fontawesome-style', get_template_directory_uri() .'/assets/css/fontawesome/css/all.css' );

    wp_enqueue_script('corporate-office-theme-js', get_template_directory_uri() . '/assets/js/theme-script.js', array('jquery'), '', true );

    wp_enqueue_script('owl.carousel-js', get_template_directory_uri() . '/assets/js/owl.carousel.js', array('jquery'), '', true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'corporate_office_scripts' );

/**
 * Enqueue Preloader.
 */
function corporate_office_preloader() {

	$corporate_office_theme_color_css = '';
	$corporate_office_preloader_bg_color = get_theme_mod('corporate_office_preloader_bg_color');
	$corporate_office_preloader_dot_1_color = get_theme_mod('corporate_office_preloader_dot_1_color');
	$corporate_office_preloader_dot_2_color = get_theme_mod('corporate_office_preloader_dot_2_color');
  	$corporate_office_preloader2_dot_color = get_theme_mod('corporate_office_preloader2_dot_color');
	$corporate_office_scroll_bg_color = get_theme_mod('corporate_office_scroll_bg_color');
	$corporate_office_scroll_color = get_theme_mod('corporate_office_scroll_color');
	$corporate_office_scroll_font_size = get_theme_mod('corporate_office_scroll_font_size');
	$corporate_office_scroll_border_radius = get_theme_mod('corporate_office_scroll_border_radius');
	$corporate_office_related_product_display_setting = get_theme_mod('corporate_office_related_product_display_setting', true);

	if(get_theme_mod('corporate_office_preloader_dot_1_color') == '') {
		$corporate_office_preloader_dot_1_color = '#ffffff';
	}
	if(get_theme_mod('corporate_office_preloader_dot_2_color') == '') {
		$corporate_office_preloader_dot_2_color = '#000000';
	}

	// Start CSS build
	$corporate_office_theme_color_css = '';

	
	if (!$corporate_office_related_product_display_setting) {
	    $corporate_office_theme_color_css .= '
	        .related.products,
	        .related h2 {
	            display: none !important;
	        }
	    ';
	}

	$corporate_office_theme_color_css .= '
		.loading, .loading2{
			background-color: '.esc_attr($corporate_office_preloader_bg_color).';
		 }
		 @keyframes loading {
		  0%,
		  100% {
		  	transform: translatey(-2.5rem);
		    background-color: '.esc_attr($corporate_office_preloader_dot_1_color).';
		  }
		  50% {
		  	transform: translatey(2.5rem);
		    background-color: '.esc_attr($corporate_office_preloader_dot_2_color).';
		  }
		}
		.load hr {
			background-color: '.esc_attr($corporate_office_preloader2_dot_color).';
		}
		a#button{
			background: '.esc_attr($corporate_office_scroll_bg_color).';
			color: '.esc_attr($corporate_office_scroll_color).' !important;
			font-size: '.esc_attr($corporate_office_scroll_font_size).'px;
			border-radius: '.esc_attr($corporate_office_scroll_border_radius).'%;
		}
	';
    wp_add_inline_style( 'corporate-office-style',$corporate_office_theme_color_css );

}
add_action( 'wp_enqueue_scripts', 'corporate_office_preloader' );

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/template-tags.php';

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/inc/custom-header.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/tgm.php';


/** * Posts pagination. */
if ( ! function_exists( 'corporate_office_blog_posts_pagination' ) ) {
	function corporate_office_blog_posts_pagination() {
		$pagination_type = get_theme_mod( 'corporate_office_blog_pagination_type', 'blog-nav-numbers' );
		if ( $pagination_type == 'blog-nav-numbers' ) {
			the_posts_pagination();
		} else {
			the_posts_navigation();
		}
	}
}

function corporate_office_sanitize_select( $input, $setting ){
    $input = sanitize_key($input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}

function corporate_office_preloader1(){
	if(get_theme_mod('corporate_office_preloader_type', 'Preloader 1') == 'Preloader 1' ) {
		return true;
	}
	return false;
}

function corporate_office_preloader2(){
	if(get_theme_mod('corporate_office_preloader_type', 'Preloader 1') == 'Preloader 2' ) {
		return true;
	}
	return false;
}

/*dropdown page sanitization*/
function corporate_office_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}

function corporate_office_sanitize_checkbox( $input ) {
  // Boolean check
  return ( ( isset( $input ) && true == $input ) ? true : false );
}

/*radio button sanitization*/
function corporate_office_sanitize_choices( $input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}

function corporate_office_sanitize_number_range( $number, $setting ) {
	
	// Ensure input is an absolute integer.
	$number = absint( $number );
	
	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;
	
	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );
	
	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );
	
	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );
	
	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}

if ( class_exists( 'WP_Customize_Control' ) ) {
	// Image Toggle Radio Buttpon
	class Corporate_Office_Image_Radio_Control extends WP_Customize_Control {

	    public function render_content() {
	 
	        if (empty($this->choices))
	            return;
	 
	        $name = '_customize-radio-' . $this->id;
	        ?>
	        <span class="customize-control-title"><?php echo esc_html($this->label); ?></span>
	        <ul class="controls" id='corporate-office-img-container'>
	            <?php
	            foreach ($this->choices as $value => $label) :
	                $class = ($this->value() == $value) ? 'corporate-office-radio-img-selected corporate-office-radio-img-img' : 'corporate-office-radio-img-img';
	                ?>
	                <li style="display: inline;">
	                    <label>
	                        <input <?php $this->link(); ?>style = 'display:none' type="radio" value="<?php echo esc_attr($value); ?>" name="<?php echo esc_attr($name); ?>" <?php
	                          	$this->link();
	                          	checked($this->value(), $value);
	                          	?> />
	                        <img src='<?php echo esc_url($label); ?>' class='<?php echo esc_attr($class); ?>' />
	                    </label>
	                </li>
	                <?php
	            endforeach;
	            ?>
	        </ul>
	        <?php
	    } 
	}
}

/**
 * Enqueue S Header.
 */
function corporate_office_sticky_header() {

	$corporate_office_sticky_header = get_theme_mod('corporate_office_sticky_header');

	$corporate_office_custom_style= "";

	if($corporate_office_sticky_header != true){

		$corporate_office_custom_style .='.stick_header{';

			$corporate_office_custom_style .='position: static;';

		$corporate_office_custom_style .='}';
	}

	wp_add_inline_style( 'corporate-office-style',$corporate_office_custom_style );

}
add_action( 'wp_enqueue_scripts', 'corporate_office_sticky_header' );

// Change number or products per row to 3
add_filter('loop_shop_columns', 'corporate_office_loop_columns');
if (!function_exists('corporate_office_loop_columns')) {
	function corporate_office_loop_columns() {
		$corporate_office_columns = get_theme_mod( 'corporate_office_products_per_row', 3 );
		return $corporate_office_columns; // 3 products per row
	}
}

//Change number of products that are displayed per page (shop page)
add_filter( 'loop_shop_per_page', 'corporate_office_shop_per_page', 9 );
function corporate_office_shop_per_page( $cols ) {
  	$cols = get_theme_mod( 'corporate_office_product_per_page', 9 );
	return $cols;
}

// Filter to change the number of related products displayed
add_filter( 'woocommerce_output_related_products_args', 'corporate_office_products_args' );
function corporate_office_products_args( $args ) {
    $args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );
    $args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );
    return $args;
}

function corporate_office_get_page_id_by_title($corporate_office_pagename){

    $args = array(
        'post_type' => 'page',
        'posts_per_page' => 1,
        'post_status' => 'publish',
        'title' => $corporate_office_pagename
    );
    $query = new WP_Query( $args );

    $page_id = '1';
    if (isset($query->post->ID)) {
        $page_id = $query->post->ID;
    }

    return $page_id;
}

function corporate_office_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'pro_version_footer' );
    $wp_customize->remove_control( 'pro_version_footer' );

}
add_action( 'customize_register', 'corporate_office_remove_customize_register', 11 );

if ( ! function_exists( 'corporate_office_file_setup' ) ) :

	function corporate_office_file_setup() {

		define( 'FREE_MNSSP_API_URL', 'https://license.themagnifico.net/api/general/' );

		if ( ! defined( 'CORPORATE_OFFICE_CONTACT_SUPPORT' ) ) {
			define('CORPORATE_OFFICE_CONTACT_SUPPORT',__('https://wordpress.org/support/theme/corporate-office/','corporate-office'));
		}
		if ( ! defined( 'CORPORATE_OFFICE_REVIEW' ) ) {
			define('CORPORATE_OFFICE_REVIEW',__('https://wordpress.org/support/theme/corporate-office/reviews/','corporate-office'));
		}
		if ( ! defined( 'CORPORATE_OFFICE_LIVE_DEMO' ) ) {
			define('CORPORATE_OFFICE_LIVE_DEMO',__('https://demo.themagnifico.net/corporate-office/','corporate-office'));
		}
		if ( ! defined( 'CORPORATE_OFFICE_GET_PREMIUM_PRO' ) ) {
			define('CORPORATE_OFFICE_GET_PREMIUM_PRO',__('https://www.themagnifico.net/products/office-wordpress-theme','corporate-office'));
		}
		if ( ! defined( 'CORPORATE_OFFICE_PRO_DOC' ) ) {
			define('CORPORATE_OFFICE_PRO_DOC',__('https://demo.themagnifico.net/eard/wathiqa/corporate-office-pro-doc/','corporate-office'));
		}
		if ( ! defined( 'CORPORATE_OFFICE_FREE_DOC' ) ) {
			define('CORPORATE_OFFICE_FREE_DOC',__('https://demo.themagnifico.net/eard/wathiqa/corporate-office-free-doc/','corporate-office'));
		}
		if ( ! defined( 'CORPORATE_OFFICE_BUNDLE_LINK' ) ) {
			define('CORPORATE_OFFICE_BUNDLE_LINK',__('https://www.themagnifico.net/products/wordpress-theme-bundle','corporate-office'));
		}

		/**
		 * Customizer additions.
		 */
		require get_template_directory() . '/inc/customizer.php';
		
	}
endif;
add_action( 'after_setup_theme', 'corporate_office_file_setup' );

/**
 * Get CSS
 */

function corporate_office_getpage_css($hook) {
	wp_register_script( 'admin-notice-script', get_template_directory_uri() . '/inc/admin/js/admin-notice-script.js', array( 'jquery' ) );
   	wp_localize_script('admin-notice-script','corporate_office',
		array('admin_ajax'	=>	admin_url('admin-ajax.php'),'wpnonce'  =>	wp_create_nonce('corporate_office_dismissed_notice_nonce')
		)
	);
	wp_enqueue_script('admin-notice-script');

    wp_localize_script( 'admin-notice-script', 'corporate_office_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
	if ( 'appearance_page_corporate-office-info' != $hook ) {
		return;
	}
}
add_action( 'admin_enqueue_scripts', 'corporate_office_getpage_css' );

//Admin Notice For Getstart
function corporate_office_ajax_notice_handler() {
	check_ajax_referer( 'corporate_office_dismissed_notice_nonce', 'wpnonce' );
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
	wp_die();
}
add_action( 'wp_ajax_corporate_office_dismissed_notice_handler', 'corporate_office_ajax_notice_handler' );

function corporate_office_deprecated_hook_admin_notice() {

    $corporate_office_dismissed = get_user_meta(get_current_user_id(), 'corporate_office_dismissable_notice', true);
    if ( !$corporate_office_dismissed) { ?>
        <div class="updated notice notice-success is-dismissible notice-get-started-class" data-notice="get_started" style="background: #f7f9f9; padding: 20px 10px; display: flex;">
	    	<div class="tm-admin-image">
	    		<img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
	    	</div>
	    	<div class="tm-admin-content" style="padding-left: 30px; align-self: center">
	    		<h2 style="font-weight: 600;line-height: 1.3; margin: 0px;"><?php esc_html_e('Thank You For Choosing ', 'corporate-office'); ?><?php echo esc_html( wp_get_theme() ); ?></h2>
	    		<p style="color: #3c434a; font-weight: 400; margin-bottom: 30px;"><?php esc_html_e('Get Started With Theme By Clicking On Getting Started.', 'corporate-office'); ?></p>
	        	<a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=corporate-office-info' )); ?>"><?php esc_html_e( 'Get started', 'corporate-office' ) ?></a>
	        	<a class="admin-notice-btn button button-primary button-hero notice-pro-btn" target="_blank" href="<?php echo esc_url( CORPORATE_OFFICE_GET_PREMIUM_PRO ); ?>"><?php esc_html_e( 'Get Premium ', 'corporate-office' ) ?></a>
	        	<a class="admin-notice-btn button button-primary button-hero notice-bundle-btn" target="_blank" href="<?php echo esc_url( CORPORATE_OFFICE_BUNDLE_LINK ); ?>"><?php esc_html_e( 'Buy All Themes - 120+ Templates', 'corporate-office' ) ?></a>
	        	<span style="padding-top: 15px; display: inline-block; padding-left: 8px;">
	        	<span style="padding-top: 15px; display: inline-block; padding-left: 8px;">
	        	<span class="dashicons dashicons-admin-links"></span>
	        	<a class="admin-notice-btn"	 target="_blank" href="<?php echo esc_url( CORPORATE_OFFICE_LIVE_DEMO ); ?>"><?php esc_html_e( 'View Demo', 'corporate-office' ) ?></a>
	        	</span>
	    	</div>
        </div>
    <?php }
}

add_action( 'admin_notices', 'corporate_office_deprecated_hook_admin_notice' );

function corporate_office_switch_theme() {
    delete_user_meta(get_current_user_id(), 'corporate_office_dismissable_notice');
}
add_action('after_switch_theme', 'corporate_office_switch_theme');
function corporate_office_dismissable_notice() {
	check_ajax_referer( 'corporate_office_dismissed_notice_nonce', 'wpnonce' );
    update_user_meta(get_current_user_id(), 'corporate_office_dismissable_notice', true);
    wp_die();
}

// Demo Content Code start //

// Ensure WordPress is loaded
if (!defined('ABSPATH')) {
    exit;
}




// Add the AJAX action to trigger theme mods import
add_action('wp_ajax_import_theme_mods', 'corporate_office_demo_importer_ajax_handler');

// Handle the AJAX request
function corporate_office_demo_importer_ajax_handler() {

    check_ajax_referer( 'theme_importer_nonce' );

    if ( ! current_user_can( 'edit_theme_options' ) ) {
        wp_send_json_error( 'Permission denied.' );
        return;
    }

    // Sample data to import
    $theme_mods_data = array(
        'header_textcolor' => '000000',  // Example: change header text color
        'background_color' => 'ffffff',  // Example: change background color
        'custom_logo'      => 123,       // Example: set a custom logo by attachment ID
        'footer_text'      => 'Custom Footer Text', // Example: custom footer text
    );

    // Call the function to import theme mods
    if (corporate_office_demo_theme_importer($theme_mods_data)) {
        // After importing theme mods, create the menu
        corporate_office_create_demo_menu();
        wp_send_json_success(array(
        	'msg' => 'Theme mods and widgets imported successfully.',
        	'redirect' => home_url()
        ));
    } else {
        wp_send_json_error('Failed to import theme mods.');
    }

    wp_die();
}

// Function to set theme mods
function corporate_office_demo_theme_importer($import_data) {
    if (is_array($import_data)) {
        foreach ($import_data as $mod_name => $mod_value) {
            set_theme_mod($mod_name, $mod_value);
        }
        return true;
    } else {
        return false;
    }
}

// Function to create demo menu
function corporate_office_create_demo_menu() {

    $menu_structure = [

        [
            'title' => 'Home',
            'slug'  => 'home',
            'template' => 'page-template/home-template.php',
        ],
        [
            'title' => 'About',
            'slug'  => 'about',
            'content' => "
                <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum. It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using 'Content here, content here', making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for 'lorem ipsum' will uncover many web sites still in their infancy. There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which don't look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isn't anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.</p>
            "
        ],
        [
            'title' => 'Services',
            'slug'  => 'services',
            'content' => "
                <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum. It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using 'Content here, content here', making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for 'lorem ipsum' will uncover many web sites still in their infancy. There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which don't look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isn't anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.</p>
            "
        ],
        [
            'title' => 'Team',
            'slug'  => 'team',
            'content' => "<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum. It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters, as opposed to using 'Content here, content here', making it look like readable English. Many desktop publishing packages and web page editors now use Lorem Ipsum as their default model text, and a search for 'lorem ipsum' will uncover many web sites still in their infancy. There are many variations of passages of Lorem Ipsum available, but the majority have suffered alteration in some form, by injected humour, or randomised words which don't look even slightly believable. If you are going to use a passage of Lorem Ipsum, you need to be sure there isn't anything embarrassing hidden in the middle of text. All the Lorem Ipsum generators on the Internet tend to repeat predefined chunks as necessary, making this the first true generator on the Internet. It uses a dictionary of over 200 Latin words, combined with a handful of model sentence structures, to generate Lorem Ipsum which looks reasonable. The generated Lorem Ipsum is therefore always free from repetition, injected humour, or non-characteristic words etc.</p>
            "
        ],

        [
            'title' => 'Pages',
            'slug'  => 'pages',
            'children' => [
                ['title' => 'Web Design', 'slug' => 'web-design'],
                ['title' => 'Marketing', 'slug' => 'marketing'],
            ]
        ],
        [
            'title' => 'Contact',
            'slug'  => 'contact',
        ],
    ];

    // ----------------------------------------------------
    // Do not modify below this line unless needed
    // ----------------------------------------------------

    $created_pages = [];

    $menu_name = 'Primary Menu';
    $location  = 'primary';
    $menu = wp_get_nav_menu_object($menu_name);

    $menu_id = (!$menu) ? wp_create_nav_menu($menu_name) : $menu->term_id;

    $create_page_and_menu = function($item, $parent_menu_id = 0, $parent_page_id = 0) 
        use (&$create_page_and_menu, &$created_pages, $menu_id) {

        $pages = get_posts( array(
            'post_type'   => 'page',
            'title'       => $item['title'],
            'post_status' => 'all',
            'numberposts' => 1,
        ) );
        $page = ! empty( $pages ) ? $pages[0] : null;

        if (!$page) {
            $page_id = wp_insert_post([
                'post_title'   => $item['title'],
                'post_type'    => 'page',
                'post_status'  => 'publish',
                'post_name'    => $item['slug'],
                'post_parent'  => $parent_page_id,
                'post_content' => !empty($item['content']) ? $item['content'] : '',
            ]);

            if (!empty($item['template'])) {
                update_post_meta($page_id, '_wp_page_template', $item['template']);
            }

        } else {
            $page_id = $page->ID;
        }

        $created_pages[$item['title']] = $page_id;

        $menu_item_id = wp_update_nav_menu_item($menu_id, 0, [
            'menu-item-title'     => $item['title'],
            'menu-item-object'    => 'page',
            'menu-item-object-id' => $page_id,
            'menu-item-type'      => 'post_type',
            'menu-item-parent-id' => $parent_menu_id,
            'menu-item-status'    => 'publish'
        ]);

        if (!empty($item['children'])) {
            foreach ($item['children'] as $child) {
                $create_page_and_menu($child, $menu_item_id, $page_id);
            }
        }
    };

    foreach ($menu_structure as $item) {
        $create_page_and_menu($item);
    }

    if (!empty($created_pages['Home'])) {
        update_option('page_on_front', $created_pages['Home']);
        update_option('show_on_front', 'page');
    }

    if (!empty($created_pages['Blog'])) {
        update_option('page_for_posts', $created_pages['Blog']);
    }

    $locations = get_theme_mod('nav_menu_locations');
    $locations[$location] = $menu_id;
    set_theme_mod('nav_menu_locations', $locations);
    
    //Top Bar
    set_theme_mod( 'corporate_office_facebook_icon', 'fab fa-facebook-f' );
    set_theme_mod( 'corporate_office_facebook_url', 'www.facebook.com' );
    set_theme_mod( 'corporate_office_twitter_icon', 'fab fa-twitter' );
    set_theme_mod( 'corporate_office_twitter_url', 'www.twitter.com' );
    set_theme_mod( 'corporate_office_intagram_icon', 'fab fa-instagram' );
    set_theme_mod( 'corporate_office_intagram_url', 'www.intagram.com' );
    set_theme_mod( 'corporate_office_linkedin_icon', 'fab fa-linkedin-in' );
    set_theme_mod( 'corporate_office_linkedin_url', 'www.linkedin.com' );
    set_theme_mod( 'corporate_office_pintrest_icon', 'fab fa-pinterest-p' );
    set_theme_mod( 'corporate_office_pintrest_url', 'www.pintrest.com' );


    //Slider

   	for($i=1;$i<=4;$i++){
         $title = 'Increase Your Web Traffic with Expert Team';
         $content = 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industrys standard dummy text ever since the 1500s';
            // Create post object
         $my_post = array(
         'post_title'    => wp_strip_all_tags( $title ),
         'post_content'  => $content,
         'post_status'   => 'publish',
         'post_type'     => 'page',
         );

         // Insert the post into the database
         $post_id = wp_insert_post( $my_post );

         if ($post_id) {
	        // Set the theme mod for the slider page
	        set_theme_mod('corporate_office_top_slider_page' . $i, $post_id);

	        $image_url = get_template_directory_uri().'/assets/image/slider.png';

			$image_id = media_sideload_image($image_url, $post_id, null, 'id');

		        if (!is_wp_error($image_id)) {
		            // Set the downloaded image as the post's featured image
		            set_post_thumbnail($post_id, $image_id);
		        }
      	}
    }

    $corporate_office_list_icon_array = array("fas fa-smile", "fas fa-smile", "fas fa-smile");
    $corporate_office_list_heading_array = array("Business Ideas", "Media Posts", "Happy Customers");

	 for($corporate_office_i=1; $corporate_office_i<=3; $corporate_office_i++) {	    
	    // title setting
	    $corporate_office_theme_mod_key = 'corporate_office_services_box_icon' . $corporate_office_i;
	    $corporate_office_theme_mod_value = $corporate_office_list_icon_array[$corporate_office_i - 1];
	    set_theme_mod($corporate_office_theme_mod_key, $corporate_office_theme_mod_value); 

	    // title setting
	    $corporate_office_theme_mod_key = 'corporate_office_services_box_heading' . $corporate_office_i;
	    $corporate_office_theme_mod_value = $corporate_office_list_heading_array[$corporate_office_i - 1];
	    set_theme_mod($corporate_office_theme_mod_key, $corporate_office_theme_mod_value); 
           
	}

    //About Us
    set_theme_mod( 'corporate_office_about_us_left_images', get_template_directory_uri().'/assets/image/about.png' );
    set_theme_mod( 'corporate_office_about_us_left_image_content', 'A Tailord Villa Rental Experience' );
    set_theme_mod( 'corporate_office_about_us_heading', 'About Us' );
    set_theme_mod( 'corporate_office_about_us_content','It is a long established fact that a reader will be distracted by the readable content of a page when looking at its layout. The point of using Lorem Ipsum is that it has a more-or-less normal distribution of letters' );
    set_theme_mod( 'corporate_office_about_us_content_1', 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industrys standard dummy text ever since the 1500s' );
   	

   	$corporate_office_about_icon_array = array("fas fa-check-square", "fas fa-check-square");
   	$corporate_office_about_heading_array = array("Technical Support", "Qualified Technicians");

	 for($corporate_office_i=1; $corporate_office_i<=2; $corporate_office_i++) {	    
	    // title setting
	    $corporate_office_theme_mod_key = 'corporate_office_about_us_box_icon' . $corporate_office_i;
	    $corporate_office_theme_mod_value = $corporate_office_about_icon_array[$corporate_office_i - 1];
	    set_theme_mod($corporate_office_theme_mod_key, $corporate_office_theme_mod_value); 

	    // title setting
	    $corporate_office_theme_mod_key = 'corporate_office_about_us_box_heading' . $corporate_office_i;
	    $corporate_office_theme_mod_value = $corporate_office_about_heading_array[$corporate_office_i - 1];
	    set_theme_mod($corporate_office_theme_mod_key, $corporate_office_theme_mod_value); 
           
	}


}

// Enqueue necessary scripts
add_action('admin_enqueue_scripts', 'demo_importer_enqueue_scripts');

function demo_importer_enqueue_scripts() {
    wp_enqueue_script(
        'demo-theme-importer',
        get_template_directory_uri() . '/assets/js/theme-importer.js', // Path to your JS file
        array('jquery'),
        null,
        true
    );

    wp_enqueue_style('demo-importer-style', get_template_directory_uri() . '/assets/css/importer.css', array(), '');

    // Localize script to pass AJAX URL to JS
    wp_localize_script(
        'demo-theme-importer',
        'demoImporter',
        array(
            'ajax_url' => admin_url('admin-ajax.php'),
            'nonce'    => wp_create_nonce('theme_importer_nonce')
        )
    );
}

/**
 * Theme Info.
 */
function corporate_office_theme_info_load() {
	require get_theme_file_path( '/inc/theme-installation/theme-installation.php' );
}
add_action( 'init', 'corporate_office_theme_info_load' );

add_action('wp_ajax_import_theme_mods', 'corporate_office_import_function');

function corporate_office_import_function() {
    check_ajax_referer('your-nonce-key', '_ajax_nonce');
    wp_send_json_success([
        'msg' => 'Demo imported successfully',
        'redirect' => admin_url('themes.php?page=theme-options')
    ]);
}


// Getstart Function

function free_mnssp_get_filtered_products($cursor = '', $search = '', $collection = 'pro') {
    $endpoint_url = FREE_MNSSP_API_URL . 'getFilteredProducts';

    $remote_post_data = array(
        'collectionHandle' => $collection,
        'productHandle' => $search,
        'paginationParams' => array(
            "first" => 12,
            "afterCursor" => $cursor,
            "beforeCursor" => "",
            "reverse" => true
        )
    );

    $body = wp_json_encode($remote_post_data);

    $options = [
        'body' => $body,
        'headers' => [
            'Content-Type' => 'application/json'
        ]
    ];
    $response = wp_remote_post($endpoint_url, $options);

    if (!is_wp_error($response)) {
        $response_body = wp_remote_retrieve_body($response);
        $response_body = json_decode($response_body);

        if (isset($response_body->data) && !empty($response_body->data)) {
            if (isset($response_body->data->products) && !empty($response_body->data->products)) {
                return  array(
                    'products' => $response_body->data->products,
                    'pagination' => $response_body->data->pageInfo
                );
            }
        }
        return [];
    }
    
    return [];
}

function free_mnssp_get_filtered_products_ajax() {
    $cursor = isset($_POST['cursor']) ? sanitize_text_field(wp_unslash($_POST['cursor'])) : '';
    $search = isset($_POST['search']) ? sanitize_text_field(wp_unslash($_POST['search'])) : '';
    $collection = isset($_POST['collection']) ? sanitize_text_field(wp_unslash($_POST['collection'])) : 'pro';

    check_ajax_referer('free_mnssp_create_pagination_nonce_action', 'mnssp_pagination_nonce');

    $get_filtered_products = free_mnssp_get_filtered_products($cursor, $search, $collection);
    ob_start();
    if (isset($get_filtered_products['products']) && !empty($get_filtered_products['products'])) {
        foreach ( $get_filtered_products['products'] as $product ) {

            $product_obj = $product->node;
            
            if (isset($product_obj->inCollection) && !$product_obj->inCollection) {
                continue;
            }

            $product_obj = $product->node;

            $demo_url = isset($product->node->metafield->value) ? $product->node->metafield->value : '';
            $product_url = isset($product->node->onlineStoreUrl) ? $product->node->onlineStoreUrl : '';
            $image_src = isset($product->node->images->edges[0]->node->src) ? $product->node->images->edges[0]->node->src : '';
            $price = isset($product->node->variants->edges[0]->node->price) ? '$' . $product->node->variants->edges[0]->node->price : ''; ?>

            <div class="mnssp-grid-item">
                <div class="mnssp-image-wrap">
                    <img src="<?php echo esc_url($image_src); ?>" alt="<?php echo esc_attr($product_obj->title); ?>">
                    <div class="mnssp-image-overlay">
                        <a class="mnssp-demo-url mnssp-btn" href="<?php echo esc_attr($demo_url); ?>" target="_blank" rel="noopener noreferrer"><?php echo esc_html('Demo'); ?></a>
                        <a class="mnssp-buy-now mnssp-btn" href="<?php echo esc_attr($product_url); ?>" target="_blank" rel="noopener noreferrer"><?php echo esc_html('Buy Now'); ?></a>
                    </div>
                </div>
                <footer>
                    <h3><?php echo esc_html($product_obj->title); ?></h3>
                </footer>
                <div class="mnssp-grid-item-price">Price: <?php echo esc_html($price); ?></div>
            </div>
        <?php }
    }
    $output = ob_get_clean();

    $pagination = isset($get_filtered_products['pagination']) ?  $get_filtered_products['pagination'] : [];
    wp_send_json(array(
        'content' => $output,
        'pagination' => $pagination
    ));
}

add_action('wp_ajax_free_mnssp_get_filtered_products', 'free_mnssp_get_filtered_products_ajax');
add_action('wp_ajax_nopriv_free_mnssp_get_filtered_products', 'free_mnssp_get_filtered_products_ajax');

function free_mnssp_get_collections() {
    
    $endpoint_url = FREE_MNSSP_API_URL . 'getCollections';

    $options = [
        'body' => [],
        'headers' => [
            'Content-Type' => 'application/json'
        ]
    ];
    $response = wp_remote_post($endpoint_url, $options);

    if (!is_wp_error($response)) {
        $response_body = wp_remote_retrieve_body($response);
        $response_body = json_decode($response_body);

        if (isset($response_body->data) && !empty($response_body->data)) {
           return  $response_body->data;
        }
        return  [];
    }

    return  [];
}